; Dig Dug game
; copyright 1982 Namco, 1993  Atari, 1994 Datasoft
; The music in the game are changed dinamically 
; during the games

.ifdef sid
 .byte "PSID"
 .word $0200         ; version 2
 .word $7C00         ; data offset
 .word $0000         ; load address in cbm format
 .byte >initmusic
 .byte <initmusic 
 .byte >play
 .byte <play
 .word $0800         ; 8 song
 .word $0700         ; default song 7
 .word $0000
 .word $0000
 .byte "Dig Dug",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .byte "<?>",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .byte "1984 Datasoft",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .word $0000
 .word $0000
 .word $0000
 
.endif

.org $8001

.byte $01,$08
.byte $0b,$08,$e8,$03,$9e,"2061",0,0,0
.org 2061
 jsr initmusic

 sei
 lda #<interr
 sta $0314
 lda #>interr
 sta $0315
      ldx  #$00
      stx  $DC0E       ; Control register A of CIA #1
      inx
      stx  $D01A       ; IRQ mask register
 cli

aaa:
 jmp aaa

interr =*
.ifndef sid
     lda  #$01
      sta  $D019       ; Interrupt indicator register
      lda  #$82
      sta  $D012       ; Reading/Writing IRQ balance value
      lda  #$1B
      sta  $D011       ; VIC control register
      lda  #$01
      sta  $D020       ; Border color
.endif      

 jsr play

.ifndef sid
    dec  $D020       ; Border color
.endif
    
 jmp $ea31

;====================================
;init music
initmusic:

.ifndef sid
  lda  #$06
.endif

  cmp #$00
  beq t1
  
  cmp #$01
  beq t2
  
  cmp #$02
  beq t3
  
  cmp #$03
  beq t4
  
  cmp #$04
  beq t5
  
  cmp #$05
  beq t6
  
  cmp #$06
  beq t7
  
  lda #$0a
  jsr setTrack
  lda #$0c
  jsr setTrack
  lda #$0d
  jsr setTrack
  rts
  
t1:
  lda #$00
  jsr setTrack
  lda #$01
  jsr setTrack
  lda #$02
  jsr setTrack
  rts
  
t2:
  lda #$0b
  jsr setTrack
  lda #$0c
  jsr setTrack
  lda #$03
  jsr setTrack
  rts
  
t3:
  lda #$0b
  jsr setTrack
  lda #$0c
  jsr setTrack
  lda #$04
  jsr setTrack
  rts
  
t4:
  lda #$0b
  jsr setTrack
  lda #$0c
  jsr setTrack
  lda #$05
  jsr setTrack
  rts

t5:
  lda #$0b
  jsr setTrack
  lda #$0c
  jsr setTrack
  lda #$06
  jsr setTrack
  rts  
  
t6:
  lda #$0b
  jsr setTrack
  lda #$0c
  jsr setTrack
  lda #$07
  jsr setTrack
  rts
  
t7:
  lda #$08
  jsr setTrack
  lda #$09
  jsr setTrack
  lda #$0d
  jsr setTrack
  rts

;=================================
; set the tracks and voice for it
;=================================
setTrack:
      sta  $EB
      asl  a
      sta  $EA
      tya
      pha
      txa
      pha
      ldy  $EB
      lda  voices,y               ; read voice number
      sta  $EB                    ; voice number
      asl  a
      tax
      ldy  $EA
      sta  $EA
      lda  tracks,y               ; read instructions track
      sta  $E0,x
      sta  $EC,x
      lda  tracks+1,y
      sta  $E1,x
      sta  $ED,x
      ldx  #$02
loopST:
      lda  $F2,x
      clc
      adc  $F5
      sta  $F2,x
      dex
      bpl  loopST
      ldx  $EB
      lda  #$00
      sta  $F2,x
      lda  #$01
      sta  $F5
      pla
      tax
      pla
      tay
      rts

voices:
  .byte $00, $01, $02, $02
  .byte $02, $02, $02, $02
  .byte $00, $01, $00, $00
  .byte $01, $02

tracks:
  .byte <track1, >track1
  .byte <track2, >track2
  .byte <track3, >track3
  .byte <track4, >track4
  .byte <track5, >track5
  .byte <track6, >track6
  .byte <track7, >track7
  .byte <track8, >track8
  .byte <track9, >track9
  .byte <track10, >track10
  .byte <track11, >track11
  .byte <track12, >track12
  .byte <track12, >track12
  .byte <track12, >track12

play:
      dec  $F5
      beq  locA
      rts
locA:
      lda  $D0
      beq  locB
      rts
locB:
      lda  #$01
      sta  $D0
      jsr  locC
      lda  #$00
      sta  $D0
      rts
locC:
      cli
      lda  $DC0D                  ; Interrupt control register CIA #1
      ldy  #$02                   ; last voice
      ldx  #$04
nextVoice:
      lda  $E1,x                  ; is active?
      beq  noActive
      lda  $00F2,y                ; note length duration
      bne  noActive
      lda  voiceIndex,y
      sta  $F6                    ; voice index
      jsr  playNext
noActive:
      dex
      dex
      dey                         ; previous voice
      bpl  nextVoice
      jmp  jmpAdjustDuration

voiceIndex:
  .byte $00, $07, $0E             ; index of the 3 voices

;==================================
; play next note in track
;==================================
playNext:
      txa
      pha
      tya
      pha
      asl  a
      stx  $EA
      sty  $EB
nextInstr:
      ldx  $EA
      ldy  $EB
      lda  ($E0,x)                ; read actual track instruction
      sta  $FE                    ; store readed value
      cmp  #$B1
      bcs  skipExecute
      and  #$07
      bne  skipExecute
      lda  $FE                    ; read stored track instruction
      cmp  #$B0                   ; end?
      bne  executeInstr
skipExecute:
      lda  #$00
      sta  $E1,x                  ; no active
      lda  #$7F
      sta  $00F2,y                ; note length duration
      jmp  exitPlay

executeInstr:
      jsr  incForNext             ; increment pointer for next reading
      lda  $FE                    ; read stored track instruction
      and  #$F8
      lsr  a
      lsr  a
      tay
      lda  instTable,y            ; read this instruction from table
      sta  $E6
      lda  instTable+1,y
      sta  $E7
      jmp  ($00E6)                ; execute the readed instruction
finishInstr:
      lda  $FE                    ; read stored track instruction
      cmp  #$40                   ; is set note length duration
      bne  nextInstr              ; exit only when note is set
exitPlay:
      pla
      tay
      pla
      tax
      rts

jmpAdjustDuration:
     jmp  adjustDuration

;==================================
; increment pointer for next reading
;==================================
incForNext:
      lda  $E0,x
      clc
      adc  #$01
      sta  $E0,x
      lda  $E1,x
      adc  #$00
      sta  $E1,x
      rts

;==================================
; set frequency control
;==================================
setFrequency:
      jsr  readNext               ; read next song instruction/data
      ldy  $F6                    ; voice index
      sta  $D400,y                ; Voice 1: Frequency control (lo byte)
      jsr  readNext               ; read next song instruction/data
      sta  $D401,y                ; Voice 1: Frequency control (hi byte)
      ldx  $EB                    ; voice number
      sta  $D8,x
      jmp  finishInstr

;==================================
; set voice control
;==================================
setControl:
      jsr  readNext               ; read next song instruction/data
      ldy  $F6                    ; voice index
      sta  $D404,y                ; Voice 1: Control registers
      jmp  finishInstr

;==================================
; set wave form pulsation amplitude
;==================================
setAmplitude:
      jsr  readNext               ; read next song instruction/data
      ldy  $F6                    ; voice index
      sta  $D402,y                ; Voice 1: Wave form pulsation amplitude (lo byte)
      jsr  readNext               ; read next song instruction/data
      sta  $D403,y                ; Voice 1: Wave form pulsation amplitude (hi byte)
      jmp  finishInstr

;==================================
; set the Attack/Decay Sustain/Release
;==================================
setADSR:
      jsr  readNext               ; read next song instruction/data
      ldy  $F6                    ; voice index
      sta  $D405,y                ; Generator 1: Attack/Decay
      jsr  readNext               ; read next song instruction/data
      sta  $D406,y                ; Generator 1: Sustain/Release
      jmp  finishInstr

;==================================
; set filter frequency
;==================================
setFilterFreq:                    ; set filter frequency
      jsr  readNext               ; read next song instruction/data
      sta  $D415                  ; Filter cut frequency: lo byte (bit 2-0)
      jsr  readNext               ; read next song instruction/data
      sta  $FF                    ; Transient data area of BASIC
      sta  $D416                  ; Filter cut frequency: hi byte
      jmp  finishInstr

;==================================
; set filter resonance
;==================================
setResonance:
      jsr  readNext               ; read next song instruction/data
      and  #$F0
      sta  $FC
      clc
      adc  $FA                    ; RS-232 output buffer pointer
      sta  $D417                  ; Filter resonance control/voice input control
      jmp  finishInstr

;==================================
; set volume and filter mode
;==================================
setVolume:
      jsr  readNext               ; read next song instruction/data
      and  #$0F
      sta  $FD
      clc
      adc  $FB                    ; Free 0 page for user program
      sta  $D418                  ; Select volume and filter mode
      jmp  finishInstr

     ; rts

;==================================
; set note lenght duration
;==================================
setDuration:
      jsr  readNext               ; read next song instruction/data
      ldy  $EB                    ; voice number
      sta  $00F2,y                ; note length duration
      jmp  finishInstr

;==================================
; change track position
;==================================
changePosition:
      ldx  $EA
      lda  $EC,x                  ; read position to go
      sta  $E0,x                  ; set new position
      lda  $ED,x
      sta  $E1,x
      jmp  finishInstr

;==================================
; set filter resonance (A)
;==================================
setResonanceA:
      ldy  $EB                    ; voice number
      lda  #$01
loopA:
      cpy  #$00
      beq  endA
      asl  a
      dey
      jmp  loopA
endA:
      ora  $FA
      sta  $FA
      lda  $FC
      clc
      adc  $FA
      sta  $D417                  ; Filter resonance control/voice input control
      jmp  finishInstr

;==================================
; set filter mode
;==================================
setFilterMode:
      jsr  readNext               ; read next song instruction/data
      and  #$F0
      sta  $FB
      clc
      adc  $FD
      sta  $D418                  ; Select volume and filter mode
      jmp  finishInstr

;==================================
; set filter resonance B
;==================================
setResonanceB:
      ldy  $EB                    ; voice number
      lda  #$FE
loopB:
      cpy  #$00
      sec
      beq  endB
      rol  a
      dey
      jmp  loopB
endB:
      and  $FA
      sta  $FA
      clc
      adc  $FC
      sta  $D417                  ; Filter resonance control/voice input control
      jmp  finishInstr

;==================================
; set number of repeat (A)
;==================================
setRepeatA:
      jsr  readNext               ; read next song instruction/data
      ldy  $EB                    ; voice number
      clc
      adc  #$01
      sta  $00D2,y                ; number of repeat factor
      jmp  finishInstr

     ; rts

;==================================
; goto the track to repeat (A)
;==================================
gotoRepeatA:
      jsr  readNext               ; read next song instruction/data
      tay
      jsr  readNext               ; read next song instruction/data
      ldx  $EB                    ; voice number
      dec  $D2,x                  ; dec repeat factor
      beq  skipRepeatA
      ldx  $EA
      sta  $E1,x                  ; change pointer
      sty  $E0,x                  ; to the next instruction
skipRepeatA:
      jmp  finishInstr

;==================================
; set various controls
;==================================
setControl11:                     ; set control voice to triangle
      lda  #$11
      bne  locSetControl

setControl10:                     ; set control voice to triangle (no A)
      lda  #$10
      bne  locSetControl

setControl41:                     ; set control voice to rectangle
      lda  #$41
      bne  locSetControl

setControl40:                     ; set control voice to rectangle (no A)
      lda  #$40

locSetControl:
      ldy  $F6                    ; voice index
      sta  $D404,y                ; Voice 1: Control registers
      jmp  finishInstr

;==================================
; set various duration
;==================================
setDuration2:                     ; set note length duration to 2
      lda  #$02
      bne  locSetDuration

setDuration6:                     ; set note length duration to 6
      lda  #$06

locSetDuration:
      ldy  $EB                    ; voice number
      sta  $00F2,y                ; set note length duration
      lda  #$40
      sta  $FE
      jmp  finishInstr

;==================================
; set number of repeat (B)
;==================================
setRepeatB:
      jsr  readNext               ; read next song instruction/data
      ldy  $EB                    ; voice number
      clc
      adc  #$01
      sta  $00D5,y                ; number of repeat factor
      jmp  finishInstr

;==================================
; goto the track to repeat (B)
;==================================
gotoRepeatB:
      jsr  readNext               ; read next song instruction/data
      tay
      jsr  readNext               ; read next song instruction/data
      ldx  $EB                    ; voice number
      dec  $D5,x                  ; dec repeat factor
      beq  skipRepeatB
      ldx  $EA
      sta  $E1,x                  ; change pointer
      sty  $E0,x                  ; to the next instruction
skipRepeatB:
      jmp  finishInstr

;==================================
; read next song instruction/data
;==================================
readNext:
      ldx  $EA
      lda  ($E0,x)                ; read the value
      pha
      jsr  incForNext             ; increment pointer for next reading
      pla
      rts

;==================================
; adjust duration of note
;==================================
adjustDuration:
      lda  $F2                    ; note length duration voice 1
      cmp  $F3                    ; note length duration voice 2
      bcc  loc1
      lda  $F3                    ; note length duration voice 2
      cmp  $F4                    ; note length duration voice 3
      bcc  loc2
      lda  $F4                    ; note length duration voice 3
      jmp  loc2
loc1:
      lda  $F2                    ; note length duration voice 1
      cmp  $F4                    ; note length duration voice 3
      bcc  loc2
      lda  $F4                    ; note length duration voice 3
loc2:
      sta  $F5
      lda  $E1                    ; seg. of track 1
      beq  loc3                   ; jump if not active
      lda  $F2                    ; note length duration voice 1
      sec
      sbc  $F5
      sta  $F2                    ; note length duration voice 1
loc3:
      lda  $E3                    ; seg. of track 2
      beq  loc4                   ; jump if not active
      lda  $F3                    ; note length duration voice 2
      sec
      sbc  $F5
      sta  $F3                    ; note length duration voice 2
loc4:
      lda  $E5                    ; seg. of track 3
      beq  loc5                   ; jump if not active
      lda  $F4                    ; note length duration voice 3
      sec
      sbc  $F5
      sta  $F4                    ; note length duration voice 3
loc5: rts

instTable:
  .byte <setControl11
  .byte >setControl11
  .byte <setFrequency
  .byte >setFrequency
  .byte <setControl
  .byte >setControl
  .byte <setAmplitude
  .byte >setAmplitude
  .byte <setADSR
  .byte >setADSR
  .byte <setFilterFreq
  .byte >setFilterFreq
  .byte <setResonance
  .byte >setResonance
  .byte <setVolume
  .byte >setVolume
  .byte <setDuration
  .byte >setDuration
  .byte <changePosition
  .byte >changePosition
  .byte <setResonanceA
  .byte >setResonanceA
  .byte <setFilterMode
  .byte >setFilterMode
  .byte <setResonanceB
  .byte >setResonanceB
  .byte <setControl10
  .byte >setControl10
  .byte <gotoRepeatA
  .byte >gotoRepeatA
  .byte <setRepeatA
  .byte >setRepeatA
  .byte <setControl41
  .byte >setControl41
  .byte <setControl40
  .byte >setControl40
  .byte <setDuration2
  .byte >setDuration2
  .byte <setDuration6
  .byte >setDuration6
  .byte <setRepeatB
  .byte >setRepeatB
  .byte <gotoRepeatB
  .byte >gotoRepeatB

track1:
  .byte $38, $0F                  ; set volume to 15
  .byte $20, $0F, $00             ; set ADSL
  .byte $00                       ; set control to 11 (triangle)
  .byte $08, $0F, $43             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control to 11 (triangle)
  .byte $08, $83, $59             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control to 11 (triangle)
  .byte $08, $C7, $70             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control to 11 (triangle)
  .byte $08, $0F, $43             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control to 11 (triangle)
  .byte $08, $45, $4B             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $B0

track2:
  .byte $20, $0F, $00             ; set ADSL
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $C1, $2C             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $D1, $12             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $A5, $1F             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $1E, $19             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $A2, $25             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $B0

track3:
  .byte $38, $0F                  ; set volume to 15
  .byte $20, $0C, $00             ; set ADSL
  .byte $18, $00, $09             ; set amplitude
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $0F, $43             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $45, $4B             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $7D, $54             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $63, $38             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $3C, $32             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $98                       ; set note length duration to 6
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $C7, $70             ; set frequency
  .byte $40, $0C                  ; set note length duration
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $98                       ; set note length duration to 6
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $79, $64             ; set frequency
  .byte $40, $12                  ; set note length duration
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $B0

track9:
  .byte $38, $0F                  ; set volume to 15
  .byte $20, $07, $00             ; set ADSL
  .byte $58, $10                  ; set filter mode
  .byte $28, $00, $87             ; set filter frequency
  .byte $30, $28                  ; set resonance
  .byte $78, $02                  ; set number of repeat (A)
rBD60:
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $3C, $32             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $70, <rBD60, >rBD60       ; goto repeat (A)

  .byte $00                       ; set control 11 (triangle)
  .byte $40, $0E                  ; set note length duration
  .byte $78, $05                  ; set number of repeat (A)
rBD6F:
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $98                       ; set note length duration to 6
  .byte $70, <rBD6F, >rBD6F       ; goto repeat (A)

  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $40, $0E                  ; set note length duration
  .byte $78, $02                  ; set number of repeat (A)
rBD7D:
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $98                       ; set note length duration to 6
  .byte $70, <rBD7D, >rBD7D       ; goto repeat (A)

  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $78, $01                  ; set number of repeat (A)
rBD88:
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $3E, $2A             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $C1, $2C             ; set frequency
  .byte $40, $0E                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $70, <rBD88, >rBD88       ; goto repeat (A)

  .byte $00                       ; set control 11 (triangle)
  .byte $08, $3E, $2A             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $C1, $2C             ; set frequency
  .byte $40, $2E                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $A2, $25             ; set frequency
  .byte $40, $16                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $78, $02                  ; set number of repeat (A)
rBDB3:
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $3E, $2A             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $70, <rBDB3, >rBDB3       ; goto repeat (A)

  .byte $00                       ; set control 11 (triangle)
  .byte $40, $0E                  ; set note length duration
  .byte $78, $05                  ; set number of repeat (A)
rBDC2:
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $98                       ; set note length duration to 6
  .byte $70, <rBDC2, >rBDC2       ; goto repeat (A)

  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $40, $0E                  ; set note length duration
  .byte $78, $02                  ; set number of repeat (A)
rBDD0:
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $98                       ; set note length duration to 6
  .byte $70, <rBDD0, >rBDD0       ; goto repeat (A)

  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $78, $01                  ; set number of repeat (A)
rBDDB:
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $A2, $25             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $3E, $2A             ; set frequency
  .byte $40, $0E                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $70, <rBDDB, >rBDDB       ; goto repeat (A)

  .byte $00                       ; set control 11 (triangle)
  .byte $08, $A2, $25             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $3C, $32             ; set frequency
  .byte $40, $48                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $48                       ; change position
  .byte $B0

track10:
  .byte $20, $37, $32             ; set ADSL
  .byte $50                       ; set resonance A
  .byte $18, $00, $08             ; set amplitude
  .byte $78, $01                  ; set number of repeat (A)
rBE07:
  .byte $A0, $01                  ; set number of repeat (B)
rBE09:
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $C3, $10             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $87, $21             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $A8, <rBE09, >rBE09       ; goto repeat (B)

  .byte $A0, $01                  ; set number of repeat (B)
rBE1C:
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $D2, $0F             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $A5, $1F             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $A8, <rBE1C, >rBE1C       ; goto repeat (B)

  .byte $A0, $01                  ; set number of repeat (B)
rBE2F:
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $EF, $0E             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $DF, $1D             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $A8, <rBE2F, >rBE2F       ; goto repeat (B)

  .byte $A0, $01                  ; set number of repeat (B)
rBE42:
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $18, $0E             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $31, $1C             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $A8, <rBE42, >rBE42       ; goto repeat (B)

  .byte $A0, $03                  ; set number of repeat (B)
rBE55:
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $4E, $0D             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $9C, $1A             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $A8, <rBE55, >rBE55       ; goto repeat (B)

  .byte $A0, $01                  ; set number of repeat (B)
rBE68:
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $8F, $0C             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $1E, $19             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $A8, <rBE68, >rBE68       ; goto repeat (B)

  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $18, $0E             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $31, $1C             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $D2, $0F             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $A5, $1F             ; set frequency
  .byte $98                       ; set note length duration to 6
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $70, <rBE07, >rBE07       ; goto repeat (A)

  .byte $90                       ; set note length duration to 2
  .byte $48                       ; change position
  .byte $B0

track4:
  .byte $38, $0F                  ; set volume to 15
  .byte $20, $00, $F0             ; set ADSL
  .byte $80                       ; set control to 41 (rectangle)
  .byte $18, $00, $08             ; set amplitude
  .byte $08, $F7, $09             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $8F, $0A             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $68, $09             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $8F, $0A             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $8F, $0C             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $4E, $0D             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $18, $0E             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $C3, $10             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $EF, $13             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $60, $16             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $31, $1C             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $DF, $1D             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $86, $23             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $16, $22             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $87, $21             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $02, $24             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $86, $23             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $3B, $25             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $02, $26             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $86, $23             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $08, $20, $24             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $B0

track5:
  .byte $38, $0F                  ; set volumne to 15
  .byte $20, $0F, $00             ; set ADSL
  .byte $80                       ; set control to 41 (rectangle)
  .byte $18, $00, $08             ; set amplitude
  .byte $78, $01                  ; set number of repeat (A)
rBF1A:
  .byte $08, $8F, $0C             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $08, $8F, $0B             ; set frequency
  .byte $40, $01                  ; set note length duration
  .byte $70, <rBF1A, >rBF1A       ; goto repeat (A)

  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $90                       ; set note length duration to 2
  .byte $80                       ; set control to 41 (rectangle)
  .byte $18, $00, $08
  .byte $08, $5F, $10             ; set frequency
  .byte $40, $08                  ; set note length duration
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $B0

track6:
  .byte $38, $0F                  ; set volume to 15
  .byte $20, $4F, $F4             ; set ADSL
  .byte $18, $00, $08             ; set amplitude
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $68, $03             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $89, $03             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $AE, $03             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $C8, $03             ; set frequency
  .byte $40, $04                  ; set note length duration
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $AE, $03             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $80                       ; set control to 41 (rectangle)
  .byte $08, $93, $03             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $88                       ; set control to 40 (rectangle no A)
  .byte $B0

track7:
  .byte $38, $0F                  ; set volume to 15
  .byte $20, $2C, $C2             ; set ADSL
  .byte $78, $02                  ; set number of repeat (A)
rBF69:
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $D6, $5E             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $C7, $70             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $97, $7E             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $70, <rBF69, >rBF69       ; goto repeat (A)

  .byte $68                       ; set control to 10 (triangle no A)
  .byte $B0

track8:
  .byte $38, $0F                  ; set volume to 15
  .byte $20, $0C, $00             ; set ADSL
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $1E, $86             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $8B, $96             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $2B, $9F             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $FA, $A8             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $30, $AB             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $06, $B3             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $FF, $5E             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $8B, $5A             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $20, $0C, $74             ; set ADSL
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $64, $56             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $68                       ; set control to 10 (triangle no A)
  .byte $B0

track12:
  .byte $10, $00                  ; set control
  .byte $08, $00, $00             ; set frequency
  .byte $B0

track11:
  .byte $38, $0F                  ; set volume to 15
  .byte $20, $07, $60             ; set ADSL
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $79, $64             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $78, $01                  ; set number of repeat (A)
rBFD0:
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $C7, $6F             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $C7, $69             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $70, <rBFD0, >rBFD0       ; goto repeat (A)

  .byte $00                       ; set control 11 (triangle)
  .byte $08, $79, $64             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $78, $02                  ; set number of repeat (A)
rBFE6:
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $0F, $43             ; set frequency
  .byte $90                       ; set note length duration to 2
  .byte $00                       ; set control 11 (triangle)
  .byte $08, $4B, $3F             ; set frequency
  .byte $40, $03                  ; set note length duration
  .byte $70, <rBFE6, >rBFE6       ; goto repeat (A)

  .byte $68                       ; set control to 10 (triangle no A)
  .byte $48                       ; change position
  .byte $B0
